/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.dao.hibernate;

import com.rjconsultores.ventaboletos.dao.EsquemaOperacionalDAO;
import com.rjconsultores.ventaboletos.entidad.EsquemaOperacional;
import java.util.Date;
import java.util.List;
import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

/**
 *
 * @author Rafius
 */
@Repository("esquemaOperacional")
public class EsquemaOperacionalHibernateDAO extends GenericHibernateDAO<EsquemaOperacional, Integer>
        implements EsquemaOperacionalDAO {

    @Autowired
    public EsquemaOperacionalHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
        setSessionFactory(factory);
    }

    public List<EsquemaOperacional> dentroVigenciaEsquemaOperacional(Date dataGeracao) {
        Criteria c = getSession().createCriteria(getPersistentClass());

        c.add(Restrictions.le("fecniciovigencia", dataGeracao));
        c.add(Restrictions.ge("fecfinvigencia", dataGeracao));
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

        return c.list();
    }

    public List<EsquemaOperacional> dentroVigenciaEsquemaOperacional(Date dataDe, Date dataAte) {
        Criteria c = getSession().createCriteria(getPersistentClass());

        c.add(Restrictions.le("fecniciovigencia", dataDe));
        c.add(Restrictions.ge("fecfinvigencia", dataAte));
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

        return c.list();
    }
}
